{$reference system.windows.forms.dll}
{$reference System.Drawing.dll}
uses
  System.Windows.Forms, System.Drawing, OpenGl, BMtGL;

var
  WW, WH: integer;
  n: byte;
  _hdc: HDC;
  textures := new cardinal[1];

procedure glGenTextures(n: integer; textures: Pointer);
external 'OpenGL32.dll' name 'glGenTextures';

procedure glBindTexture(target: GLenum; texture: GLuint);
external 'OpenGL32.dll' name 'glBindTexture';

type
  GraphField = class(PictureBox)
    timer: Timer;
    components: System.ComponentModel.IContainer;
    
    procedure TimerTick(sender: Object; e: system.EventArgs);
    begin
      if n = 0 then
        Milliseconds;
      
      glClearColor(single(0.0), single(0.0), single(0.0), single(0.0));
      glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
      
      glBindTexture(GL_TEXTURE_2D, textures[0]);
      
      glBegin(GL_QUADS);
      glTexCoord2f(0.0, 1.0);glVertex3f(-1, 1, 0);
      glTexCoord2f(0.0, 0.0);glVertex3f(-1, -1, 0);
      glTexCoord2f(1.0, 0.0);glVertex3f(1, -1, 0);
      glTexCoord2f(1.0, 1.0);glVertex3f(1, 1, 0);
      glEnd;
      
      SwapBuffers(_hdc);
      glFlush;
      
      n += 1;
      if n >= 60 then
      begin
        writeln(MillisecondsDelta);
        n := 0;
      end;
    end;
    
    constructor(x, y, w, h, I: integer);
    begin
      self.Left := x;
      self.top := y;
      self.Width := w;
      self.Height := h;
      components := new System.ComponentModel.Container;
      timer := new System.Windows.Forms.Timer(self.components);
      timer.Enabled := true;
      timer.Interval := I;
      _hdc := GetDC(self.Handle.ToInt32());
      OpenGLInit(self.Handle);
      
      glEnable(GL_TEXTURE_2D);
      glGenTextures(1, @textures[0]);
      
      var tw, th: integer;
      var texture0 := LoadOpenGLImage('1.bmp', @tw, @th, RGB);
      glBindTexture(GL_TEXTURE_2D, textures[0]);
      gluBuild2DMipmaps(GL_TEXTURE_2D, 3, tw, th, GL_RGB, GL_UNSIGNED_BYTE, @texture0[0]);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	
      //glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, tw, th, 0, GL_RGB, GL_UNSIGNED_BYTE, @texture0[0]);
      //glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
      //glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );
      //glBindTexture(GL_TEXTURE_2D, 0); 
      
      timer.Tick += TimerTick;
    end;
  end;

var
  MF: System.windows.forms.Form;
  GF: GraphField;

function GetDesktopWindow: system.IntPtr;external 'User32.dll' name 'GetDesktopWindow';

procedure GetWindowRect(hWnd: system.IntPtr; var lpRect: system.Drawing.Rectangle);external 'User32.dll' name 'GetWindowRect';

begin
  MF := new Form;
  MF.WindowState := FormWindowState.Maximized;
  MF.FormBorderStyle := system.windows.forms.FormBorderStyle.None;
  begin
    var a: system.Drawing.Rectangle;
    GetWindowRect(GetDesktopWindow, a);
    WW := a.Width;
    WH := a.Height;
  end;
  GF := new GraphField(0, 0, WW, WH, 15);
  MF.Controls.Add(GF);
  system.windows.forms.Application.Run(MF);
end.